'' This is a very simple example of an application program using the display and
'' keyboard drivers.  It displays a banner, waits for a keypress before continuing,
'' then goes on to reload the OS command interpreter from the boot EEPROM.

'' When compiling this, there are different versions of several objects (OS_loader
'' and OS_dispText) that vary depending on the type of display to be used.  Please
'' copy them from the appropriate folder (directory) of the OS's distribution to the
'' Propeller Tool's library folder (directory).  If, for some reason, you have to
'' recompile the OS itself, other display-specific objects (OS_initialization and
'' OS_dispTextInit) have to be copied as well.

'' Like all main programs, this needs a _clkmode and _xinfreq constant declaration.
'' Since the OS is already running, no initialization needs to be called to use the
'' keyboard, display, or I2C drivers

'' There are comments at the beginning of OS_loader, OS_dispText, and OS_keyboard
'' that describe the routines within each object and how they're used.

OBJ
  ldr : "OS_loader"             ' I2C driver and SPIN loader
  dsp : "OS_dspText"            ' Display driver
  key : "OS_keyboard"           ' Keyboard driver
  
CON
  _clkmode = ldr#clockMode
  _xinfreq = ldr#xtalClock

PUB start
  dsp.str(@msg1)                ' Display the first part
  dsp.str(@msg2)                ' Display the second part
  key.getkey                    ' Discard the key code
  ldr.bootEEPROM(ldr#bootAddr)  ' Reload from the bootEEPROM

DAT
msg1  byte  "Hi there!",dsp#Cr
      byte  "This is your friendly Propeller!",dsp#Cr,0
msg2  byte  "Type any character to exit",dsp#Cr
      byte  "Back to the Operating System",dsp#Cr,0
                            